// Copyright 2019 Google LLC.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

// @generated by protoc-gen-es v1.0.0
// @generated from file google/api/expr/v1beta1/decl.proto (package google.api.expr.v1beta1, syntax proto3)
/* eslint-disable */
// @ts-nocheck

import type { BinaryReadOptions, FieldList, JsonReadOptions, JsonValue, PartialMessage, PlainMessage } from "@bufbuild/protobuf";
import { Message, proto3 } from "@bufbuild/protobuf";
import type { Expr } from "./expr_pb.js";

/**
 * A declaration.
 *
 * @generated from message google.api.expr.v1beta1.Decl
 */
export declare class Decl extends Message<Decl> {
  /**
   * The id of the declaration.
   *
   * @generated from field: int32 id = 1;
   */
  id: number;

  /**
   * The name of the declaration.
   *
   * @generated from field: string name = 2;
   */
  name: string;

  /**
   * The documentation string for the declaration.
   *
   * @generated from field: string doc = 3;
   */
  doc: string;

  /**
   * The kind of declaration.
   *
   * @generated from oneof google.api.expr.v1beta1.Decl.kind
   */
  kind: {
    /**
     * An identifier declaration.
     *
     * @generated from field: google.api.expr.v1beta1.IdentDecl ident = 4;
     */
    value: IdentDecl;
    case: "ident";
  } | {
    /**
     * A function declaration.
     *
     * @generated from field: google.api.expr.v1beta1.FunctionDecl function = 5;
     */
    value: FunctionDecl;
    case: "function";
  } | { case: undefined; value?: undefined };

  constructor(data?: PartialMessage<Decl>);

  static readonly runtime: typeof proto3;
  static readonly typeName = "google.api.expr.v1beta1.Decl";
  static readonly fields: FieldList;

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): Decl;

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): Decl;

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): Decl;

  static equals(a: Decl | PlainMessage<Decl> | undefined, b: Decl | PlainMessage<Decl> | undefined): boolean;
}

/**
 * The declared type of a variable.
 *
 * Extends runtime type values with extra information used for type checking
 * and dispatching.
 *
 * @generated from message google.api.expr.v1beta1.DeclType
 */
export declare class DeclType extends Message<DeclType> {
  /**
   * The expression id of the declared type, if applicable.
   *
   * @generated from field: int32 id = 1;
   */
  id: number;

  /**
   * The type name, e.g. 'int', 'my.type.Type' or 'T'
   *
   * @generated from field: string type = 2;
   */
  type: string;

  /**
   * An ordered list of type parameters, e.g. `<string, int>`.
   * Only applies to a subset of types, e.g. `map`, `list`.
   *
   * @generated from field: repeated google.api.expr.v1beta1.DeclType type_params = 4;
   */
  typeParams: DeclType[];

  constructor(data?: PartialMessage<DeclType>);

  static readonly runtime: typeof proto3;
  static readonly typeName = "google.api.expr.v1beta1.DeclType";
  static readonly fields: FieldList;

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): DeclType;

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): DeclType;

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): DeclType;

  static equals(a: DeclType | PlainMessage<DeclType> | undefined, b: DeclType | PlainMessage<DeclType> | undefined): boolean;
}

/**
 * An identifier declaration.
 *
 * @generated from message google.api.expr.v1beta1.IdentDecl
 */
export declare class IdentDecl extends Message<IdentDecl> {
  /**
   * Optional type of the identifier.
   *
   * @generated from field: google.api.expr.v1beta1.DeclType type = 3;
   */
  type?: DeclType;

  /**
   * Optional value of the identifier.
   *
   * @generated from field: google.api.expr.v1beta1.Expr value = 4;
   */
  value?: Expr;

  constructor(data?: PartialMessage<IdentDecl>);

  static readonly runtime: typeof proto3;
  static readonly typeName = "google.api.expr.v1beta1.IdentDecl";
  static readonly fields: FieldList;

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): IdentDecl;

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): IdentDecl;

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): IdentDecl;

  static equals(a: IdentDecl | PlainMessage<IdentDecl> | undefined, b: IdentDecl | PlainMessage<IdentDecl> | undefined): boolean;
}

/**
 * A function declaration.
 *
 * @generated from message google.api.expr.v1beta1.FunctionDecl
 */
export declare class FunctionDecl extends Message<FunctionDecl> {
  /**
   * The function arguments.
   *
   * @generated from field: repeated google.api.expr.v1beta1.IdentDecl args = 1;
   */
  args: IdentDecl[];

  /**
   * Optional declared return type.
   *
   * @generated from field: google.api.expr.v1beta1.DeclType return_type = 2;
   */
  returnType?: DeclType;

  /**
   * If the first argument of the function is the receiver.
   *
   * @generated from field: bool receiver_function = 3;
   */
  receiverFunction: boolean;

  constructor(data?: PartialMessage<FunctionDecl>);

  static readonly runtime: typeof proto3;
  static readonly typeName = "google.api.expr.v1beta1.FunctionDecl";
  static readonly fields: FieldList;

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): FunctionDecl;

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): FunctionDecl;

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): FunctionDecl;

  static equals(a: FunctionDecl | PlainMessage<FunctionDecl> | undefined, b: FunctionDecl | PlainMessage<FunctionDecl> | undefined): boolean;
}

